// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//


///////////////////////////////////////////////////////////////// 
const EDITOR_URL = "chrome://browser/content/flock/blog/editor.xul"

flock.blog = {};

flock.blog.createAPIFromName = function(aName) {/*{{{*/
    var B;
    // should link this to the dropdown better
    switch(aName) {
        case "livejournal":
        case "atom":
           dump("Atom...\n");
           B = Components.classes[BLOG_ATOM].getService(IBLOG_WEB_SERVICE);
        break;
        case "wordpress":
        case "typepad":
        case "typo":
        case "drupal":
        case "metaweblog":
        case "movabletype":
        case "movableblog":
           dump("Movabletype...\n");
           B = Components.classes[BLOG_MOVABLETYPE].getService(IBLOG_WEB_SERVICE);
        break;
        case "blogger":
           dump("Blogger...\n");
           B = Components.classes[BLOG_BLOGGER].getService(IBLOG_WEB_SERVICE);
        break;
        default:
            //throw new Error("hmm.  why didn't we find an api?");
        break;
    }
    return B;
}/*}}}*/

flock.blog.__defineGetter__("service", function () {/*{{{*/
    if (flock.blog._service) return flock.blog._service;
    flock.blog._service = Components.classes[BLOG_SERVICE].getService(IBLOG_SERVICE);
    return flock.blog._service;
});/*}}}*/

// Functions related to the posts save location /*{{{*/
flock.blog.locationPrefIsSet = function() {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefService)
                  .getBranch("flock.blog.");
    var value = null;
    try{
       value = prefs.getCharPref("saveLocation");
    } catch(e) {}
    return (value != null);
}

flock.blog.setSaveLocation = function(aFile) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefService)
                  .getBranch("flock.blog.");
    prefs.setCharPref("saveLocation", aFile.path);
}

// Return an nsIFile pointing to the directory
flock.blog.getSaveLocation = function() {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Components.interfaces.nsIPrefService)
                  .getBranch("flock.blog.");
    var value = null;
    var init_dir = Components.classes["@mozilla.org/file/local;1"].
        createInstance(Components.interfaces.nsILocalFile);
    
    try {
       value = prefs.getCharPref("saveLocation");
    } catch(e) {}
    
    if (value) {
        init_dir.initWithPath(value);
    }
    else {
        var localeService = Components.classes["@mozilla.org/intl/nslocaleservice;1"].getService(Components.interfaces.nsILocaleService);
        var stringBundleService = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService);
        var stringBundle = stringBundleService.createBundle("chrome://flock/locale/blog/blog.properties", localeService.getApplicationLocale());
        // The pref is not set... 
        var dirService = Components.classes["@mozilla.org/file/directory_service;1"]
                 .getService(Components.interfaces.nsIProperties);
        var init_path_pref;
// platform specificness
//@line 109 "/home/build/tinderbuild/src/flock/mozilla/browser/components/flock/blog/content/blogCommon.js"
        init_path_pref = dirService.get("Home", Components.interfaces.nsIFile).path;
//@line 111 "/home/build/tinderbuild/src/flock/mozilla/browser/components/flock/blog/content/blogCommon.js"
        init_dir.initWithPath(init_path_pref);
        init_dir.appendRelativePath(stringBundle.GetStringFromName("flock.blog.saveDirectory"));
        
        if (!init_dir.exists())
          init_dir.create(1, 0700);
        // XXX andy: no more of this complex stuff for now
        prefs.setCharPref("saveLocation", init_path_pref);
    }

    return init_dir;
}

flock.blog.__defineGetter__("credit", function () {
  var prefs = Components.classes["@mozilla.org/preferences-service;1"].
              getService(Components.interfaces.nsIPrefBranch);
  try {
    var value = prefs.getBoolPref("flock.blog.creditFlock");
  } catch(e) {
    prefs.setBoolPref("flock.blog.creditFlock", false);
    value = false;
  }
  return value;
});

/*}}}*/

// Functions related to the default account /*{{{*/
function flock_blogSetDefaultAccountIndex(i) {
    flock_setIntPref("flock.blog.defaultAccountIndex", i);
}

function flock_blogGetDefaultAccountIndex(i) {
    try {
        return flock_getIntPref("flock.blog.defaultAccountIndex");
    }
    catch(e) {
        return 0;
    }
}

flock.blog.setDefaultAccount = function (acct) {
    flock_setCharPref("flock.blog.defaultAccount", acct);
}

flock.blog.__defineSetter__("defaultAccount", function (acct) {
    flock_setCharPref("flock.blog.defaultAccount", acct);
});

flock.blog.__defineGetter__("defaultAccount", function () {
    // var defaultAccount = flock_getCharPref("flock.blog.defaultAccount");
    // if(!defaultAccount) flock_setCharPref("flock.blog.defaultAccount", FLOCK_BLOG_DRAFTS_FOLDER);
    return flock_getCharPref("flock.blog.defaultAccount");
});
/*}}}*/

// New post, open post /*{{{*/
var flock_blogNewPostCommand =
{
    isEnabled: function() {
        return true;
    },
    exec: function() {
        var params = {
            file : 0,
            title : "",
            content : ""
        };
        flock_blogDoOpenPost(EDITOR_URL, params);
        return;
    },
}

var flock_blogOpenPostCommand =
{
    isEnabled: function() {
        return true;
    },
    exec: function() {
        var theFP = PromptToOpenFile();

        if (theFP){
            var theFile = theFP.file;
            flock.blog.service.addRecent(theFP.fileURL.fileName.replace('.html',''),
                          theFP.fileURL.filePath);
            var params = {
                file : theFile,
                title : "",
                content : ""
            };
            flock_blogDoOpenPost(EDITOR_URL, params);
        }
        return;
    },
}

function flock_blogOpenFileCommand (aFile)
{
        var theFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
        theFile.initWithPath(aFile.getAttribute("filename"));

        if (theFile){
            // flock.blog.settings.addRecent(theFP.fileURL);
            var params = {
                file : theFile,
                title : "",
                content : ""
            };
            flock_blogDoOpenPost(EDITOR_URL, params);
        }
        return;
}
/*}}}*/

var flock_blogBlogThisCommand = {/*{{{*/
    target: null,
    isEnabled: function() {
        return true;
    },
    onDrop: function(aSource) {
        this.target = aSource;
        this.exec();
    },
    exec: function() {
        var topWindow = flock_mostRecentNavigator();
        var node = null;

        if(topWindow.document.popupNode) {
            node = topWindow.document.popupNode;
        }
        else {
            node = this.target;//this is set by a drop handler in the topbar - crazy
        }

        var contentDetector = new nsContentDetector();
        contentDetector.setTarget(node);

        var selection = $$("content").mCurrentBrowser.contentWindow.getSelection() + "";
        var data = "";
        var location = $$("content").mCurrentBrowser.contentWindow.location + "";
        if(location.match(/^chrome:\/\/.+/)) {
            location = "";
        }
        var title = $$("content").mCurrentBrowser.contentTitle + "";

        if(contentDetector.onImage) {
            data = '<blockquote cite="' + location + '">' + '<img src="' + contentDetector.imageURL + '" />' + "</blockquote>";
            if(title.length==0) title = location;
            data += '<p class="citation"><cite cite="' + location + '"><a href="' + location + '">' + title + '</a>' + "</cite></p><p></p>";
        }
        else if(contentDetector.onLink) {
            var link = contentDetector.link;
            var location = link.href;
            var title = link.innerHTML;
            data = '<a href="' + location + '">' + title + "</a> <br/><br/>";
        }
        else if(selection.length == 0) {
//            $$("content").mCurrentBrowser.contentWindow.location.spec;
            data = '<a href="' + location + '">' + title + "</a> <br/><br/>";
        }
        else {
            data = '<blockquote cite="' + location + '">' + selection + "</blockquote>";
            if(title.length==0) title = location;
            data += '<p class="citation"><cite cite="' + location + '"><a href="' + location + '">' + title + '</a>' + "</cite></p><p></p>";
        }
        data = data.replace(/\n/g,"");
        data = data.replace(/\r/g,"");

        var params = {
            file : 0,
            title : FLOCK_BLOG_DEFAULT_TITLE,
            content : data + "<p></p>"
        };
        flock_blogDoOpenPost(EDITOR_URL, params);
        return;
    },
}/*}}}*/

var flock_blogCreateAccountCommand = {/*{{{*/
    isEnabled: function() {
        return true;
    },
    exec: function() {
        flock_blogOpenWizard();
    },
}/*}}}*/

// Dialogs /*{{{*/

// Params: file (when opening), title, content (for blogthis)
function flock_blogDoOpenPost(aUrl, aParams) {
   try {
//@line 305 "/home/build/tinderbuild/src/flock/mozilla/browser/components/flock/blog/content/blogCommon.js"
        window.openDialog(aUrl, "_blank", "chrome,close,titlebar,resizable=yes,toolbar=no,dialog=no,scrollbars=yes,centerscreen", aParams);
//@line 307 "/home/build/tinderbuild/src/flock/mozilla/browser/components/flock/blog/content/blogCommon.js"
    }
    catch(e) {
        alert(e);
    }
}

function flock_blogGotoService() {
    var aUrl = "http://www.flock.com/fiveways/togetstarted/with/blogging/";
    window.opener.open(aUrl);
}

function flock_blogOpenWizard(param) {
    var ugly = false;
    if(!param) ugly = true;
    if(!param) param = "";
    if(ugly) window.open("chrome://browser/content/flock/blog/blogAccountWizard.xul", "accountWizard", "chrome,modal,centerscreen", param); 
    else window.openDialog("chrome://browser/content/flock/blog/blogAccountWizard.xul", "accountWizard", "modal,centerscreen", param); 
}
/*}}}*/

// Date/Time Helpers /*{{{*/

function padDate(str) {
    str = str + "";
    if(str.length==1) return "0" + str;
    return str;
}

function padDateTime(str) {
    str = str + "";
    var diff = 16 - str.length;
    for(var i=0;i<diff;++i)
    {
        str = "0" + str;
    }
    return str;
}
/*}}}*/

