/*  *
 * ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code Shadows.com API client implementation.
 *
 * The Initial Developer of the Original Code is
 * Pluck Corporation. This code is Copyright (C) 2005, 2006
 * All Rights Reserved.
 *
 * Contributor(s):
 *   Carl Brown (carlb@shadows.com)
 *   Duane Fields (dfields@pluck.com)
 *
 * ***** END LICENSE BLOCK ***** */

shadows.setCollections = function (aUsername, aPassword, aCollectionArray, fnCallBack) {

    debug('setCollections: called with \n');
    debug('setCollections: aUsername "' + aUsername + '"\n');
    debug('setCollections: aPassword "' + aPassword + '"\n');
    this.msetCollectionsRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("collections"));
    
    debug('setCollections: XMLRPCUrl "' + shadows.XmlRpc.Url("collections") + '"\n');

    var args = [{UserName: aUsername, Password: aPassword}];
    args.push(aCollectionArray);
        
    debug('setCollections: args "' + args + '"\n');

    var listener = new Object ();
    listener.onResult = function (aResult) {
        debug('setCollections: result \n');
        dd (aResult);
        debug('setCollections: returning "' + aResult + '"\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(aResult);
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {
            fnCallBack.onResult(aResult);
        }
    }
    listener.onFault = function (aFaultCode, aFaultString) {
        PluckDebug.fail('setCollections: fault code=' + aFaultCode + '\n');
        PluckDebug.fail('                     string="' +  aFaultString + '\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {
            fnCallBack.onFault(aFaultCode, aFaultString);
        }
    }
    listener.onError = function (aMessage) {
        PluckDebug.fail('setCollections: error "'+aMessage+'"\n');
        this.result=false;
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'error "'+aMessage+'"\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {
            fnCallBack.onError(aMessage);
        }
    }
    this.msetCollectionsRPC.call ('shadows.urlcollection.auth.set', args, listener);
    return true;
}

shadows.getCollections = function (aUsername, aPassword, aCollectionNameArray, fnCallBack) {

    debug('getCollections: called with \n');
    debug('getCollections: aUsername "' + aUsername + '"\n');
    debug('getCollections: aPassword "' + aPassword + '"\n');
    debug('getCollections: aURL Array "' + aCollectionNameArray + '"\n');
    this.mgetCollectionsRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("collections"));
    
    debug('getCollections: XMLRPCUrl "' + shadows.XmlRpc.Url("collections") + '"\n');

    var args = [{UserName: aUsername, Password: aPassword}];
    args.push(aCollectionNameArray);
        
    debug('getCollections: args "' + args + '"\n');

        var listener = new Object ();
    listener.onResult = function (aResult) {
        debug('getCollections: result \n');
        debug('getCollections: returning "' + aResult + '"\n');
        debug('getCollections: returning "' + aResult['Response'] + '"\n');
        debug('getCollections: returning "' + aResult['Response']['OverallStatus'] + '"\n');
        debug('getCollections: returning "' + aResult['Response']['OverallStatus']['Entry'] + '"\n');
        debug('getCollections: returning "' + aResult['Response']['OverallStatus']['Entry']['Status'] + '"\n');
        dd (aResult);
        if(typeof fnCallBack=="function") {
            fnCallBack(aResult);
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {
            fnCallBack.onResult(aResult);
        }
    }
    listener.onFault = function (aFaultCode, aFaultString) {
        PluckDebug.fail('getCollections: fault code=' + aFaultCode + '\n');
        PluckDebug.fail('                     string="' +  aFaultString + '\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {
            fnCallBack.onFault(aFaultCode, aFaultString);
        }

    }
    listener.onError = function (aMessage) {
        PluckDebug.fail('getCollections: error "'+aMessage+'"\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'error "'+aMessage+'"\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {
            fnCallBack.onError(aMessage);
        }
    }
    this.mgetCollectionsRPC.call ('shadows.urlcollection.auth.get', args, listener);

    return true;
}

shadows.getAllCollections = function (aUsername, aPassword, version, fnCallBack) {

    debug('getAllCollections: called with \n');
    debug('getAllCollections: aUsername "' + aUsername + '"\n');
    debug('getAllCollections: aPassword "' + aPassword + '"\n');
    this.mgetAllCollectionsRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("collections"));
    
    debug('getAllCollections: XMLRPCUrl "' + shadows.XmlRpc.Url("collections") + '"\n');

    var args = [{UserName: aUsername, Password: aPassword}];
    args.push(version)
            
    debug('getAllCollections: args "' + args + '"\n');

        var listener = new Object ();
    listener.onResult = function (aResult) {
        debug('getAllCollections: result \n');
        dd (aResult);
        debug('getAllCollections: returning "' + aResult + '"\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(aResult);
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {
            fnCallBack.onResult(aResult);
        }
    }
    listener.onFault = function (aFaultCode, aFaultString) {
        PluckDebug.fail('getAllCollections: fault code=' + aFaultCode + '\n');
        PluckDebug.fail('                     string="' +  aFaultString + '\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {
            fnCallBack.onFault(aFaultCode, aFaultString);
        }
    }
    listener.onError = function (aMessage) {
        PluckDebug.fail('getAllCollections: error "'+aMessage+'"\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'error "'+aMessage+'"\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {
            fnCallBack.onError(aMessage);
        }
    }
    this.mgetAllCollectionsRPC.call ('shadows.urlcollection.auth.getall', args, listener);

    return true;
}

shadows.RemoveCollections = function (aUsername, aPassword, aCollectionNameArray, fnCallBack) {

    debug('RemoveCollections: called with \n');
    debug('RemoveCollections: aUsername "' + aUsername + '"\n');
    debug('RemoveCollections: aPassword "' + aPassword + '"\n');
    debug('RemoveCollections: aURL Array "' + aCollectionNameArray + '"\n');
    this.mRemoveCollectionsRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("collections"));
    
    debug('RemoveCollections: XMLRPCUrl "' + shadows.XmlRpc.Url("collections") + '"\n');

    var args = [{UserName: aUsername, Password: aPassword}];
    args.push(aCollectionNameArray);
        
    debug('RemoveCollections: args "' + args + '"\n');

        var listener = new Object ();
    listener.onResult = function (aResult) {
        debug('RemoveCollections: result \n');
        dd (aResult);
        debug('RemoveCollections: returning "' + aResult + '"\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(aResult);
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {
            fnCallBack.onResult(aResult);
        }
    }
    listener.onFault = function (aFaultCode, aFaultString) {
        PluckDebug.fail('RemoveCollections: fault code=' + aFaultCode + '\n');
        PluckDebug.fail('                     string="' +  aFaultString + '\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {
            fnCallBack.onFault(aFaultCode, aFaultString);
        }
    }
    listener.onError = function (aMessage) {
        PluckDebug.fail('RemoveCollections: error "'+aMessage+'"\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'error "'+aMessage+'"\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {
            fnCallBack.onError(aMessage);
        }
    }
    this.mRemoveCollectionsRPC.call ('shadows.urlcollection.auth.remove', args, listener);

    return true;
}

shadows.GetCollectionVersion = function (aUsername, aPassword, fnCallBack) {

    debug('GetCollectionVersion: called with \n');
    debug('GetCollectionVersion: aUsername "' + aUsername + '"\n');
    debug('GetCollectionVersion: aPassword "' + aPassword + '"\n');
    this.mGetCollectionVersionRPC = new flockXmlRpcServer (shadows.XmlRpc.Url("collections"));
    
    debug('GetCollectionVersion: XMLRPCUrl "' + shadows.XmlRpc.Url("collections") + '"\n');

    var args = [{UserName: aUsername, Password: aPassword}];
        
    debug('GetCollectionVersion: args "' + args + '"\n');

        var listener = new Object ();
    listener.onResult = function (aResult) {
        debug('GetCollectionVersion: result \n');
        dd (aResult);
        debug('GetCollectionVersion: returning "' + aResult + '"\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(aResult);
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onResult=="function")) {
            fnCallBack.onResult(aResult);
        }
    }
    listener.onFault = function (aFaultCode, aFaultString) {
        PluckDebug.fail('GetCollectionVersion: fault code=' + aFaultCode + '\n');
        PluckDebug.fail('                     string="' +  aFaultString + '\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'fault code=' + aFaultCode + 'string="' +  aFaultString + '\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onFault=="function")) {
            fnCallBack.onFault(aFaultCode, aFaultString);
        }
    }
    listener.onError = function (aMessage) {
        PluckDebug.fail('GetCollectionVersion: error "'+aMessage+'"\n');
        if(typeof fnCallBack=="function") {
            fnCallBack(false, 'error "'+aMessage+'"\n');
        } else if((typeof fnCallBack=="object")&&(typeof fnCallBack.onError=="function")) {
            fnCallBack.onError(aMessage);
        }
    }
    this.mGetCollectionVersionRPC.call ('shadows.urlcollection.auth.getversion', args, listener);

    return true;
}
