const RDFCU = Components.classes['@mozilla.org/rdf/container-utils;1'].getService (Components.interfaces.nsIRDFContainerUtils);
const RDFS = Components.classes['@mozilla.org/rdf/rdf-service;1'].getService (Components.interfaces.nsIRDFService);
const RDF_TYPE = RDFS.GetResource ('http://www.w3.org/1999/02/22-rdf-syntax-ns#type');
const RDF_FOLDER = RDFS.GetResource ('http://home.netscape.com/NC-rdf#Folder');
const RDF_BOOKMARK = RDFS.GetResource ('http://home.netscape.com/NC-rdf#Bookmark');
const RDF_LIVEMARK = RDFS.GetResource ('http://home.netscape.com/NC-rdf#Livemark');
const RDF_ICON = RDFS.GetResource ('http://home.netscape.com/NC-rdf#Icon');
const RDF_NAME = RDFS.GetResource ('http://home.netscape.com/NC-rdf#Name');
const RDF_DESCRIPTION = RDFS.GetResource ('http://home.netscape.com/NC-rdf#Description');
const RDF_URL = RDFS.GetResource ('http://home.netscape.com/NC-rdf#URL');
const RDF_FEEDURL = RDFS.GetResource ('http://home.netscape.com/NC-rdf#FeedURL');
const RDF_TOOLBAR = RDFS.GetResource ('http://home.netscape.com/NC-rdf#BookmarksToolbarFolder');

const nsIRDFLiteral = Components.interfaces.nsIRDFLiteral;


function walkBookmarks (aDataSource, aNode, aTags, aLevel, aCollection) {
	var name, description, url, favicon, isFeed;
	var children;
	var child;
	var node_type;
        var skip=false;
        var tag;
        var collection;
        var toolbar = false;

	// dump("hello i am " + aNode + '\n');
	aNode.QueryInterface( Components.interfaces.nsIRDFResource );
	try {
	    node_type = aDataSource.GetTarget( aNode, RDF_TYPE, true ).QueryInterface( Components.interfaces.nsIRDFResource ).ValueUTF8;
	} catch (e) { return; }

	if (node_type == 'http://home.netscape.com/NC-rdf#Folder') {
//		dump('  --- decided it was a folder \n');
		if (!RDFCU.IsSeq (aDataSource, aNode)) {
			// its not a rdf seq - ignore it
			return;
		}
		name = null;
		try {
			name = aDataSource.GetTarget (aNode, RDF_NAME, true).
				QueryInterface (Components.interfaces.nsIRDFLiteral).Value;
		} catch (e) {
			// hmm - that sucks
		}
        var should = false;
        try {
            toolbar = aDataSource.GetTarget (aNode, RDF_TOOLBAR, true).
                QueryInterface (Components.interfaces.nsIRDFLiteral).Value;
                if(toolbar) {
                    name = $("strings").getString("flock.favorites.toolbarName");
                    if(flock.favorites.isCollection(name)) {
                        flock.favorites.renameCollection(name, "Flock Faves");

                    }
                    skip=true;

                }
        } catch (e) {
        }

        collection = flock.favorites.createCollection (name);

		if (aLevel && name != null) {
			// transform folder name into tag name

            /**
             *
             *  We don't want to create tags basing on those
             *  names. We're not going to i18n it (bart's request)
             */
            if (name == 'Bookmarks Toolbar Folder') skip=true;
            if (name == 'From Firefox') skip=true;
            if (name == 'From Internet Explorer') skip=true;

            if (!skip) {
			    tag = name.replace( /\W/g, ''); // tags don't have non a-z, A-Z, or numbers in them
			
			    // append to a copy of aTags
			    if (tag.length > 0) {
			    	if (aTags.length > 0 ) {
					    aTags = aTags + ',' + tag;
				    }
				    else {
					    aTags = tag;
				    }
			    }
			}
		}

		children = null;
		try {
			children = RDFCU.MakeSeq (aDataSource, aNode).GetElements ();
		} catch (e) {
			// oh well
		}

        var hasChildren = false;
		while (children && children.hasMoreElements ()) {
			child = children.getNext ();
			walkBookmarks (aDataSource, child, aTags, aLevel + 1, collection);
            hasChildren = true;
		}

        // if there were children...
        if (hasChildren) {
            try {
                toolbar = aDataSource.GetTarget (aNode, RDF_TOOLBAR, true).
                    QueryInterface (Components.interfaces.nsIRDFLiteral).Value;
            } catch (e) {
                // hmm - that sucks
            }
            if (toolbar) {
                // if its the toolbar then we should set our default topbar to be
                // this collection
                flock.favorites.service.setToolbarCollection (
                        flock.favorites.service.getCollectionResource (name));
            }
        }
        
	} else if (node_type == 'http://home.netscape.com/NC-rdf#Bookmark' || 
	           node_type == 'http://home.netscape.com/NC-rdf#Livemark') {
		try { name = aDataSource.GetTarget (aNode, RDF_NAME, true).QueryInterface (nsIRDFLiteral).Value; }
		catch (e) { name = ''; dump(e + '\n' ); }
		try { description = aDataSource.GetTarget (aNode, RDF_DESCRIPTION, true).QueryInterface (nsIRDFLiteral).Value; }
		catch (e) { description = ''; }
		try { url = aDataSource.GetTarget (aNode, RDF_URL, true).QueryInterface (nsIRDFLiteral).Value; }
		catch (e) { url = null; }
		try { favicon = aDataSource.GetTarget (aNode, RDF_ICON, true).QueryInterface (nsIRDFLiteral).Value; }
		catch (e) { favicon = null; }

                if (node_type == 'http://home.netscape.com/NC-rdf#Livemark') {
		    try { url = 'feed:' + aDataSource.GetTarget (aNode, RDF_FEEDURL, true).QueryInterface (nsIRDFLiteral).Value; }
		    catch (e) { url = null; }
                    isFeed = 'true';
                } else {
                    isFeed = null;
                }

		if (url == null) {
			// missing url
			return;
		}

                var fav = flock.favorites.createFavorite( {
                        url: url,
			name: name,
			favicon: favicon,
			description: description,
			local: 'true',
			tags: aTags,
			feed: isFeed
			} );

		if (fav && aCollection) {
                    flock.favorites.service.addFavoriteToCollection( fav.url, aCollection );
		}

	} else {
		dump('migration - not sure what to do with this node of type:\n\t');
	        dump(node_type+'\n\n');
	}
}


// Migration
    
function doTheImportDeed() {
    flock.favorites.service.disableHasFeeds ();
    walkBookmarks(RDFS.GetDataSource('rdf:bookmarks'), RDFS.GetResource('NC:BookmarksRoot'), 'imported', 0, null ); 
    flock.favorites.service.enableHasFeeds ();
    flock_setCharPref('browser.search.selectedEngine', 'Yahoo'); // XXX this should be in branding
    flock.favorites.service.Flush();
}

