//ala termie

flock.photo = {};
flock.photouploader = {};

flock.photouploader.__defineGetter__("service", function(){/*{{{*/
    if (flock.photouploader._service) return flock.photouploader._service;
    flock.photouploader._service = flock.xpcom.getService(
        '@mozilla.org/rdf/datasource;1?name=flock-photo-uploads',
        'flockIPhotoUploadService'
    );
    return flock.photouploader._service;
});/*}}}*/    
    
flock.photo.__defineGetter__("service", function () {/*{{{*/
    if (flock.photo._service) return flock.photo._service;
    flock.photo._service = flock.xpcom.getService(
        '@mozilla.org/rdf/datasource;1?name=flock-photo',
        'flockIPhotoService'
    );
    return flock.photo._service;
});/*}}}*/

flock.photo.__defineGetter__("datasource", function () {/*{{{*/
    if(flock.photo._datasource) return flock.photo._datasource;
    flock.photo._datasource = new RDFDataSource();
    flock.photo._datasource.Init(flock.photo.service);
    return flock.photo._datasource;
});/*}}}*/

flock.photo.api = {};

flock.photo.api.load = function() {
    var jsFile = flock_getCharPref("flock.photo.api.jsfile");
    if(!jsFile) {
        flock_photoSetAPI("Flickr", "FlickrCalls", "chrome://browser/content/flock/photo/flickrAPI.js", "@flock.com/?photo-api-flickr;1");
    }
    flock.photo.api.calls = {};// clear existing UI calls
    jsFile = flock_getCharPref("flock.photo.api.jsfile");
    flock.load(jsFile);
}

flock.photo.util = {};

flock.photo.util.helper = {};

flock.photo.util.__defineGetter__("gm", function () {/*{{{*/
    if (flock.photo._gm) return flock.photo._gm;
    flock.photo.util._gm = flock.xpcom.getService(
        '@flock.com/imagescaler;1',
        'flockIImageScaler'
    );
    return flock.photo.util._gm;
});/*}}}*/

flock.photo.util.__defineGetter__("gmAsync", function () {/*{{{*/
    if (flock.photo._gmAsync) return flock.photo._gmAsync;
    flock.photo.util._gmAsync = flock.xpcom.getService(
        '@flock.com/asyncImageScaler;1',
        'flockIAsyncImageScaler'
    );
    return flock.photo.util._gmAsync;
});/*}}}*/


flock.photo.util.createArgs = function() {
    var rval = new Array();
    for(var i=0;i<arguments.length;++i) {
        if(arguments[i]==null) continue;
        rval.push(arguments[i] + "");
    }
    var argString = rval.join(" ");
    dump("ARGS: " + argString + "\n");
    return rval;
}

flock.photo.util.createArgsAsync = function() {
    var rval = Components.classes["@mozilla.org/array;1"].createInstance(Components.interfaces.nsIMutableArray);
    for(var i=0;i<arguments.length;++i) {
    	var string = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
        if(arguments[i]==null) continue;
		string.data = arguments[i] + "";
        rval.appendElement(string, false);
    }
    return rval;
}

flock.photo.util.resize = function(aSize, aSrc, aDest) {
    var dims = aSize + "x" + aSize + ">";
//    var args = flock.photo.util.createArgs("convert", "-size", dims, aSrc, "-resize", dims, aDest);
    var args = flock.photo.util.createArgs("convert", "-size", dims, aSrc, "-coalesce", "-geometry", dims, aDest);
    flock.photo.util.gm.doMagick(args, args.length);
}

flock.photo.util.thumb = function(aSize, aSrc, aDest) {
    var dims = aSize + "x" + aSize;
    var args = flock.photo.util.createArgs("convert", aSrc, 
        "-resize", "x" + aSize*2, "-resize",  aSize*2 + "x<", 
        "-resize", "50%", "-gravity", "center", "-crop", dims + "+0+0",  
        "-page",
        "0x0+0+0",
        aDest);
    flock.photo.util.gm.doMagick(args, args.length);
}

flock.photo.util.resizeAsync = function(aSize, aSrc, aDest, aListener) {
    var dims = aSize + "x" + aSize + ">";
    //var args = flock.photo.util.createArgsAsync("convert", "-size", dims, aSrc, "-resize", dims, aDest);
    var args = flock.photo.util.createArgsAsync("convert", "-size", dims, aSrc, "-coalesce", "-geometry", dims, aDest);
    flock.photo.util.gmAsync.doAsyncMagick(args, aListener);
}

flock.photo.util.thumbAsync = function(aSize, aSrc, aDest, aListener) {
    var dims = aSize + "x" + aSize;
    var args = flock.photo.util.createArgsAsync("convert", aSrc, 
        "-resize", "x" + aSize*2, "-resize",  aSize*2 + "x<", 
        "-resize", "50%", "-gravity", "center", "-crop", dims + "+0+0",  
        "-page",
        "0x0+0+0",
        aDest);
    flock.photo.util.gmAsync.doAsyncMagick(args, aListener);
}

flock.photo.util.rotate = function(aDegrees, aSrc, aDest) {
    var args = flock.photo.util.createArgs("convert", aSrc, "-rotate", aDegrees, aDest);
    flock.photo.util.gm.doMagick(args, args.length);
}

/*
flock.photo.util.crop = function(aSrc, aDest, aWidth, aHeight, aHorzOffset, aVertOffset) {
    var dims = aWidth + "x" + aHeight;
    var args = flock.photo.util.createArgs("convert", aSrc, 
    "-crop",  dims + "+" + aHorzOffset + "+" + aVertOffset, aDest);
    flock.photo.util.gm.doMagick(args, args.length);
}
*/

flock.photo.util.cropExt = function(aSrc, aDest, aWidth, aHeight, aHorzOffset, aVertOffset, aRot, aSize) {
    var dims = aWidth + "x" + aHeight;
    var rot = aRot;
    var args = flock.photo.util.createArgs("convert", aSrc, 
    "-coalesce", "-crop",  dims + "+" + aHorzOffset + "+" + aVertOffset, 
    "-page",
    "0x0+0+0",
    (aRot?"-rotate":null), 
    (aRot?aRot:null), 
    (aSize?"-resize":null), 
    (aSize?aSize + "x" + aSize + ">":null), 
    aDest);
    flock.photo.util.gm.doMagick(args, args.length);
}

flock.photo.util.getDimensions = function(aSrc) {
    var aDims = {};
    aDims.x = 0;
    aDims.y = 0;
    
    var args = flock.photo.util.createArgs("identify", aSrc);
    flock.photo.util.gm.doMagick(args, args.length);
    var profileDir = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
    if (profileDir) {
        var inFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        inFile.initWithPath(profileDir.path);
        inFile.append("flockimageinfo.txt");
        var rawText = flock.photo.util.readFile(inFile);
        
        // could this be better done wtih a REGEXP???
        rawText.match(/.+?(\d+)x(\d+)\+(\d+)\+(\d+).+/);

        aDims.x = RegExp.$1;
        aDims.y = RegExp.$2;
        return aDims;
    }
}

flock.photo.util.reverseString = function(aStr) {
    var inp = aStr;
    var revRawText = '';
        
    for (i = 0; i <= inp.length; i++) {
        revRawText = inp.charAt (i) + revRawText;
    }
    
    return revRawText;
}

flock.photo.util.readFile = function(aFile) {
    try{  
       var inStream =  Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
       inStream.init(aFile,0x01,0444,null);
    
       var sInStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
       sInStream.init(inStream);
    } catch (e) { alert(e); }
    
    try {
        var str = sInStream.read(aFile.fileSize-1);
    } catch (e) { dump(e); }
    sInStream.close();
    inStream.close();
    return str;
}

flock.photo.util.getTmpDir = function() {
    var sinkFile = Components.classes["@mozilla.org/file/directory_service;1"]
        .getService(Components.interfaces.nsIProperties)
        .get("ProfD", Components.interfaces.nsIFile);
    sinkFile.append("flock_imagecache");
    if(!sinkFile.exists()) {
        sinkFile.createUnique(1,0700);
    }
    return sinkFile;
}

flock.photo.util.getFileFromPath = function(aPath) {
    var file = Components.classes["@mozilla.org/file/local;1"]
            .createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(aPath);
    return file;
}

flock.photo.util.removeFileBySpec = function(aSpec, aRecursive) {
    dump(aSpec + "\n");
    try {
        var file = flock.photo.util.getFileFromURL(aSpec);
        file.remove(aRecursive);
    }
    catch(e) {
    }
}

flock.photo.util.removeFileByPath = function(aPath, aRecursive) {
    dump(aPath + "\n");
    try {
        var file = flock.photo.util.getFileFromPath(aPath);
        file.remove(aRecursive);
    }
    catch(e) {
    }
}

flock.photo.util.getFileFromPath = function(aPath) {
    var file = Components.classes["@mozilla.org/file/local;1"]
            .createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(aPath);
    return file;
}

flock.photo.util.getFileFromURL = function(aURL) {
    var ios = Components.classes["@mozilla.org/network/io-service;1"]
        .getService(Components.interfaces.nsIIOService);
    var fileHandler = ios.getProtocolHandler("file")
        .QueryInterface(Components.interfaces.nsIFileProtocolHandler);
    var sourceSpec = fileHandler.getFileFromURLSpec(aURL);
    var sourceFile = Components.classes["@mozilla.org/file/local;1"]
        .createInstance(Components.interfaces.nsILocalFile);
    sourceFile.initWithFile(sourceSpec);
    return sourceFile;
}

flock.photo.util.getURLFromFile = function(aFile) {
    var ios = Components.classes["@mozilla.org/network/io-service;1"]
        .getService(Components.interfaces.nsIIOService);
    var fileHandler = ios.getProtocolHandler("file")
        .QueryInterface(Components.interfaces.nsIFileProtocolHandler);
    return fileHandler.getURLSpecFromFile(aFile);
}

flock.photo.util.transferExif = function(sourceUrl, targetUrl) {
	var sourceFile = flock.photo.util.getFileFromURL(sourceUrl);
	var targetFile = flock.photo.util.getFileFromURL(targetUrl);
	var sourcePath = sourceFile.path;
	var targetPath = targetFile.path;
	
	var args = flock.photo.util.createArgs("convert", sourcePath, sourcePath + ".exif");
	flock.photo.util.gm.doMagick(args, args.length);
	
	try {
		var exifFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	    exifFile.initWithPath(sourcePath + ".exif");
	    exifFile.moveTo(null, exifFile.leafName + ".app1");
		
		args = flock.photo.util.createArgs("convert", "-profile", sourcePath + ".exif.app1", targetPath, targetPath);
		flock.photo.util.gm.doMagick(args, args.length);
        flock.photo.util.removeFileByPath(sourcePath + ".exif.app1");
	} catch(e) {}
}

flock.photo.util.callCount = 0;
flock.photo.util.getUniqueFname = function(aFName) {
    aFName.match(/.+\.(.+)/);
    var ext = RegExp.$1;
    if(!ext) ext = "";
    var now = new Date();
    var sinkFileName = hex_md5(aFName + now + flock.photo.util.callCount++);
    sinkFileName = sinkFileName + "." + ext;
    return sinkFileName;
}

flock.photo.util.params2Dictionary = function(aParams) {
    var DICTIONARY_CONTRACTID     = '@mozilla.org/dictionary;1';
    var nsIDictionary             = Components.interfaces.nsIDictionary;
    var dict = Components.classes["@mozilla.org/dictionary;1"].createInstance(Components.interfaces.nsIDictionary);
    for(var p in aParams) {
        var val = Components.classes['@mozilla.org/supports-string;1'].createInstance(Components.interfaces.nsISupportsString);
        val.data = aParams[p];
        dict.setValue(p, val);
    }
    return dict;
}

flock.photo.util.dictionary2Params = function(aDictionary) {
    var params = {};
    var obj = {};
    var count = {};
    var keys = aDictionary.getKeys(count, obj);
    for(var i=0;i<keys.length;++i) {
        var supports = aDictionary.getValue(keys[i]);
        var supportsString = supports.QueryInterface(Components.interfaces.nsISupportsString);
        var val = supportsString.toString();
        params[keys[i]] = val;
    }
    return params;
}


flock.photo.util.photoImportQueue = new Array();

flock.photo.util.processPhotoImportQueue = function() {
    if(this.photoImportQueue.length == 0) return;
    var createPhotoUploadListener = this.photoImportQueue.shift();
    flock.photouploader.service.createPhotoUpload(createPhotoUploadListener, createPhotoUploadListener.url)
}

flock.photo.util.handlePhotoDrop = function(url, hoverChild, aIsOneShot, aTarget) {
	var inst = this;
    var uploadsvc = flock.photouploader.service;
    var utils = flock.photo.util;
    var createPhotoUploadListener = {
    	url: url,
        onCreatePhotoUpload: function(aPhotoUpload) {
            if (!aIsOneShot) {
                utils.launchUploader();//guarantee that this will fire the selection handler in the uploader
                uploadsvc.addPhotoUpload((hoverChild?hoverChild:null),aPhotoUpload);
                inst.processPhotoImportQueue();
            } else {
                utils.launchSinglePhotoUpload(aPhotoUpload, aTarget);
            }
        }
    }
    this.photoImportQueue.push(createPhotoUploadListener);
}

function PhotoDropProcessor(aList, aHoverChild)  {
    this.mList = aList;
    this.mHoverChild = aHoverChild;
    this.mLauncherFunc = flock.photo.util.launchUploader;
    this.mUploaderSvc = flock.photouploader.service;
}

PhotoDropProcessor.prototype = {
    mList: null,
    start: function() {
        var str = "";
        if(this.mHoverChild) {
            var newThing = Components.classes['@flock.com/photo-upload;1']
                .createInstance(Components.interfaces.flockIPhotoUpload);
            newThing.id = this.mHoverChild.getAttribute("id");
            this.mHoverChild = newThing;
        }
        this.next();
    },
    next: function() {
        if(this.mList.length==0) return;
        var url = this.mList.shift();
        if (url.split(":")[0] == "file") {
        	this.mUploaderSvc.createPhotoUpload(this, url);
        } else {
        	var URIFixup = Components.classes["@mozilla.org/docshell/urifixup;1"].getService(Components.interfaces.nsIURIFixup);
			var uri = URIFixup.createFixupURI(url, URIFixup.FIXUP_FLAG_NONE);
			
        	var IOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
			var channel = IOService.newChannelFromURI(uri);
			
			var self = this;
			
			var streamListener = {
				processor: self,
				sinkFile: null,
				sinkBufferStream: null,
				
				onStartRequest: function(request, context) {
					var extension;
					switch (channel.contentType) {
						case "image/jpeg": extension = "jpg"; break;
						case "image/png": extension = "png"; break;
						case "image/gif": extension = "gif"; break;
						default: extension = "jpg"; break;
					}
					var sinkFileName = "remoteImage." + extension;
		
				    this.sinkFile = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
					this.sinkFile.append("flock_imagecache");
					if(!this.sinkFile.exists()) {
					    this.sinkFile.createUnique(this.sinkFile.DIRECTORY_TYPE, 0700);
					}
					if(sinkFileName) this.sinkFile.append(sinkFileName);

				    var sinkFileStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
					sinkFileStream.init(this.sinkFile, 0x02 | 0x08 | 0x20, 0664, 0);
					this.sinkBufferStream = Components.classes["@mozilla.org/network/buffered-output-stream;1"].createInstance(Components.interfaces.nsIBufferedOutputStream);
					this.sinkBufferStream.init(sinkFileStream, 65536 * 4);
				},
				
				onStopRequest: function(request, context, statusCode) {
				    var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
					var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
					this.sinkBufferStream.close();
					this.processor.mUploaderSvc.createPhotoUpload(this.processor, fileHandler.getURLSpecFromFile(this.sinkFile));
				},
				
				onDataAvailable: function(request, context, inputStream, offset, count) {
					this.sinkBufferStream.writeFrom(inputStream, count);
				}
			}

			channel.asyncOpen(streamListener, null);
        }
    },
    onCreatePhotoUpload: function(aPhotoUpload) {
        this.mUploaderSvc.addPhotoUpload((this.mHoverChild?this.mHoverChild:null),aPhotoUpload);
        this.mLauncherFunc();
        this.next();
    },
    onUploadCreateError: function(aFile) {
        alert("The photo " + aFile + " is invalid and cannot be added to the photo uploader.");
        this.next();
    },
    onError: function() {
    },
    cancel: function() {
        //not impl
    },
}

// transform obj
flock.photo.util.transform = function() {};
flock.photo.util.transform.prototype.type = null;
flock.photo.util.transform.prototype.params = Array();

flock.photo.util.getPreferredServices = function() {
    var rval = {};
    var apimgr = Components.classes['@flock.com/photo-api-manager;1?']
        .getService(Components.interfaces.flockIPhotoAPIManager);
    var preferredServices = apimgr.preferredServices;
    while(preferredServices.hasMoreElements()) {
        var svc = preferredServices.getNext();
        rval[svc.shortName] = svc;
    }
    return rval;
}

flock.photo.util.deleteChildren = function(aElm) {
    var toDelete = new Array();
    for(var i=0;i<aElm.childNodes.length;++i) {
        var kid = aElm.childNodes.item(i);
        if(!kid.getAttribute("dontdelete")) {
            toDelete.push(kid);
        }
    }
    for(var i=0;i<toDelete.length;++i) {
        var kid = toDelete[i];
        kid.parentNode.removeChild(kid);
    }
}

flock.photo.util.launchUploader = function() {
    var apimgr = Components.classes['@flock.com/photo-api-manager;1?']
        .getService(Components.interfaces.flockIPhotoAPIManager);
    if (apimgr.preferredServices.hasMoreElements()) {
        flock.photo.util.showUploaderWindow();
    } else {
        flock.photo.util.launchSettings();
        // if they pressed cancel or something went wrong
        if (apimgr.getDefaultService())
            flock.photo.util.showUploaderWindow();
    }
}

flock.photo.util.showUploaderWindow = function() {
    var wmSvc = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var uploaderWindow = wmSvc.getMostRecentWindow("Flock:PhotoUploader");
    if (uploaderWindow)
        uploaderWindow.focus();
    else {
        window.open("chrome://browser/content/flock/photo/photoUploader.xul", "PhotoUploader", "chrome=1,resizable=0,width=680,height=610");
    }
}

flock.photo.util.launchSettings = function(aParams) {
    //window.openDialog("chrome://browser/content/flock/photo/photoAccountListing.xul", "PhotoAccountDlg", "modal, centerscreen", aParams);
    //window.openDialog("chrome://browser/content/flock/preferences/preferences.xul", "PhotoAccountDlg", "modal, centerscreen", "panePhotos");
    openFlockPreferences("panePhotos");
}

flock.photo.util.launchSinglePhotoUpload = function(aPhoto, aTarget) {
    var apimgr = Components.classes['@flock.com/photo-api-manager;1?']
        .getService(Components.interfaces.flockIPhotoAPIManager);
    if (apimgr.preferredServices.hasMoreElements()) {
        flock.photo.util.showSinglePhotoUploadWindow(aPhoto, aTarget);
    } else {
        flock.photo.util.launchSettings();
        // if they pressed cancel or something went wrong
        if (apimgr.getDefaultService())
            flock.photo.util.showSinglePhotoUploadWindow(aPhoto, aTarget);
    }
}

flock.photo.util.showSinglePhotoUploadWindow = function(aPhoto, aTarget) {
    var params = {};
    params.aPhoto = aPhoto;
    params.aTarget = aTarget;
    window.openDialog("chrome://browser/content/flock/photo/photoPropsQuickUpload.xul", "QuickUploader", "modal,close,centerscreen", params);
}

flock.photo.util.launchUploadOptions = function(aParams) {
   var rv = window.openDialog("chrome://browser/content/flock/photo/flockPhotoUploadOptions.xul", "_blank", "modal,centerscreen", aParams); 
   return rv;
}

flock.photo.util.launchPhotoProperties = function(aParams) {
    var rv = window.openDialog("chrome://browser/content/flock/photo/photoProperties.xul", "_blank", "modal,close,centerscreen", aParams);
}

flock.photo.util.isAPhoto = function(aURL) {
    if (aURL.indexOf("file") != 0) return false;
    var lc = aURL.toLowerCase();
    if (lc.match(/.+jpg$/)) return true;
    if (lc.match(/.+jpeg$/)) return true;
    if (lc.match(/.+png$/)) return true;
    if (lc.match(/.+gif$/)) return true;
    return false;
}

flock.photo.util.populateServicesPopup = function(aPopup) {
    var apimgr = Components.classes['@flock.com/photo-api-manager;1?']
                  .getService(Components.interfaces.flockIPhotoAPIManager);
    flock.photo.util.deleteChildren(aPopup);
    var hasDefaultSvc = apimgr.getDefaultService() != null;
    var preferredServices = flock.photo.util.getPreferredServices();
    var selectedIndex=1;
    var i=0;
    for(var p in preferredServices) {
        var svc = preferredServices[p];
        if (svc) {
            var serviceName = svc.serviceName; if(!serviceName) continue;//tmp workaround
            var account = document.createElement("menuitem");
            account.setAttribute('value', svc.shortName);
            account.setAttribute('label', 'Use ' + serviceName);
            if (hasDefaultSvc) {
                if (svc.shortName == apimgr.getDefaultService().shortName) {
                    account.setAttribute('style', 'font-weight: bold');
                    selectedIndex = i;
                }
            }
            aPopup.appendChild(account);
            i++;
        }
    }
    var menuseparator = document.createElement('menuseparator');
    var configure = document.createElement('menuitem');
    configure.setAttribute('command', 'cmd_launchSettings')
    configure.setAttribute('label', 'Setup Account');

    aPopup.appendChild(menuseparator);
    aPopup.appendChild(configure);
    
    aPopup.parentNode.selectedIndex = selectedIndex;
}


var photoUploadDNDObserver = {

    canHandleMultipleItems: true,

    onDragOver: function(aEvent, aFlavor, aSession) {
    },
    
    onDragEnter: function(aEvent, aSession) {
        dump("photoUploadDNDObserver: onDragEnter\n");
    },
    
    onDragExit: function(aEvent, aSession) {
        dump("photoUploadDNDObserver: onDragExit\n");
    },

    onDrop: function(aEvent, aDropData, aSession) {
        dump("photoUploadDNDObserver: drop: sourceNode: " + (aSession.sourceNode ? aSession.sourceNode.localName : "none") + " items: " + aDropData.dataList.length + "\n");
        aEvent.stopPropagation();
		var photoURLs = new Array();

        for (var c = 0; c < aDropData.dataList.length; c++) {
            var supports = aDropData.dataList[c].dataList[0].supports;
            var contentType = aDropData.dataList[c].dataList[0].flavour.contentType;
            var url;
            
            if (aSession.sourceNode && aSession.sourceNode.localName == "IMG") {
            	contentType = null;
            }
            
			switch (contentType) {
				case "application/x-moz-file":
		            try {
		                var file = supports.QueryInterface(Components.interfaces.nsIFile);
		                handleFile(file, photoURLs);
		            } catch(e) {}
		           	break;
		        case "flock/shelficon":
	                url = aSession.sourceNode.url;
		            photoURLs.push(url);
		            break;
		        default:
		            if (aSession.sourceNode && aSession.sourceNode.localName == "IMG") {
		                url = aSession.sourceNode.getAttribute("src");
		                var baseURI = aSession.sourceDocument.baseURI;
		                var URIFixup = Components.classes["@mozilla.org/docshell/urifixup;1"].getService(Components.interfaces.nsIURIFixup);
		                url = URIFixup.createFixupURI(baseURI, URIFixup.FIXUP_FLAG_NONE).resolve(url);
		                photoURLs.push(url);
		            } else {
		            	url = supports.QueryInterface(Components.interfaces.nsISupportsString).data;
		            	url = url.split("\n")[0];
			            if (isAPhoto(url)) {
			            	photoURLs.push(url);
			            } else {
			            	if (url.indexOf("file") == 0) {
		        			    var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
							    var fileHandler = ios.getProtocolHandler("file").QueryInterface(Components.interfaces.nsIFileProtocolHandler);
							    var sourceSpec = fileHandler.getFileFromURLSpec(url);
							    if (sourceSpec.exists()) {
							    	handleFile(sourceSpec, photoURLs);
							    }
							}
		        		}
			        }
			        break;
            }
        }
        
		dump("photoUploadDNDObserver: found " + photoURLs.length + " image(s)\n");

        var hoverNode = null;
        if(aEvent.target.nodeName=="slideyitem") hoverNode = aEvent.target.parentNode.hoverChild.firstChild;
        if(aEvent.target.nodeName=="photoupload") {
            var slideyboxHover = aEvent.target.parentNode.parentNode.hoverChild;
            if(slideyboxHover) {
                hoverNode = slideyboxHover.firstChild;
            }
        }

        var dropProcessor = new PhotoDropProcessor(photoURLs, hoverNode); 
        dropProcessor.start();

        function handleFile(file, photoURLs) {
        	if (file.isDirectory()) {
        		var enum = file.directoryEntries;
        		while (enum.hasMoreElements()) {
        			var child = enum.getNext().QueryInterface(Components.interfaces.nsIFile);
        			handleFile(child, photoURLs);
        		}
        	} else {
        		url = flock.photo.util.getURLFromFile(file);
        		if (isAPhoto(url)) {
        			photoURLs.push(url);
        		}
        	}
        }
        
        function isAPhoto(aURL) {
		    if (aURL.indexOf("file") != 0) return false;
		    var lc = aURL.toLowerCase();
		    if (lc.match(/.+jpg$/)) return true;
		    if (lc.match(/.+jpeg$/)) return true;
		    if (lc.match(/.+png$/)) return true;
		    if (lc.match(/.+gif$/)) return true;
		    return false;
		}
    },

    getSupportedFlavours: function() {
        var flavors = new FlavourSet();
        flavors.appendFlavour("application/x-moz-file", "nsIFile");
        flavors.appendFlavour("text/x-moz-url");
        flavors.appendFlavour("flock/shelficon");
        flavors.appendFlavour("application/x-moz-url");
        return flavors;
    }
}
